/* $Id$ */

/* datadesc - describing the data to exchange                               */

/* module's public interface exported within GRAS, but not to end user.     */

/* Authors: Olivier Aumage, Martin Quinson                                  */
/* Copyright (C) 2003, 2004 the GRAS posse.                                 */

/* This program is free software; you can redistribute it and/or modify it
   under the terms of the license (GNU LGPL) which comes with this package. */

#ifndef GRAS_DATADESC_INTERFACE_H
#define GRAS_DATADESC_INTERFACE_H

#include "gras_private.h"

void gras_datadesc_init(void);
void gras_datadesc_exit(void);

/* - main functions - */
/* compare two data type description */
int
gras_datadesc_type_cmp(const gras_datadesc_type_t *d1,
		       const gras_datadesc_type_t *d2);


/* Copy a described data in memory */
gras_error_t 
gras_datadesc_cpy(gras_datadesc_type_t *type, void *src, void **dst);

/* Send stuff */
gras_error_t 
gras_datadesc_send(gras_socket_t *sock, gras_datadesc_type_t *type, void *src);

/* Receive (and convert) stuff */
gras_error_t
gras_datadesc_recv(gras_socket_t *sock, gras_datadesc_type_t *type, void **dst);


/* -- */

/* free a given ddt */
void gras_ddt_free(gras_datadesc_type_t **type);

/* declare in the given set, and retrieve afterward */
gras_error_t gras_ddt_register(gras_datadesc_type_t *type);
gras_error_t gras_ddt_get_by_name(const char            *name,
				  gras_datadesc_type_t **type);
gras_error_t gras_ddt_get_by_code(int                    code,
				  gras_datadesc_type_t **type);


#endif /* GRAS_DATADESC_INTERFACE_H */
